﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.UltraChart.Resources.Appearance;
using Infragistics.UltraChart.Core;
using Infragistics.UltraChart.Core.Primitives;
using Infragistics.UltraChart.Shared.Styles;
using Infragistics.UltraChart.Core.Layers;

namespace WindowsFormsApplication11
{
    public partial class Form1 : Form
    {

        private NumericSeries series1;
        private NumericSeries series2;
        private NumericSeries series3;
        private NumericSeries series4;
        private NumericSeries series5;
        private Point startPoint, endPoint;
        private bool IsMouseDown = false;
        private bool IsValid = true;
        private double scaleX, scrollX, scaleY, scrollY;
        private bool IsUpdateRequired = true;

        private AxisItem axis1;
        private AxisItem axisX;

        public Form1()
        {
            InitializeComponent();

            this.ultraChart1.ChartType = ChartType.Composite;

            ChartArea area = new ChartArea();
            this.ultraChart1.CompositeChart.ChartAreas.Add(area);

            axis1 = new AxisItem();
            axis1.Extent = 50;
            axis1.DataType = AxisDataType.Numeric;
            axis1.Labels.ItemFormatString = "<DATA_VALUE:##.##>%";
            axis1.OrientationType = AxisNumber.Y_Axis;
            axis1.ScrollScale.Visible = true;

            axis1.RangeType = AxisRangeType.Custom;
            axis1.RangeMin = 100;
            axis1.RangeMax = 0;
            axis1.TickmarkInterval = 10;
            axis1.TickmarkStyle = AxisTickStyle.DataInterval;
            area.Axes.Add(axis1);

            axisX = new AxisItem();
            axisX.DataType = AxisDataType.String;
            axisX.Labels.ItemFormatString = "<ITEM_LABEL>";
            axisX.OrientationType = AxisNumber.X_Axis;
            axisX.SetLabelAxisType = SetLabelAxisType.ContinuousData;
            axisX.Extent = 50;
            axisX.ScrollScale.Visible = true;
            area.Axes.Add(axisX);


            ChartLayerAppearance myColumnLayer = new ChartLayerAppearance();
            myColumnLayer.ChartType = ChartType.LineChart;
            myColumnLayer.ChartArea = area;


            DataTable dt = new DataTable();
            dt.Columns.Add("Month");
            dt.Columns.Add("2007");
            dt.Columns.Add("2008");
            dt.Columns.Add("2009");
            dt.Columns.Add("2010");
            dt.Columns.Add("2011");

            dt.Rows.Add("Jan", 35, 10, 40, 30, 45);
            dt.Rows.Add("Feb", 2, 15, 55, 35, 80);
            dt.Rows.Add("Mar", 5, 35, 25, 50, 90);
            dt.Rows.Add("Apr", 2, 60, 35, 70, 80);
            dt.Rows.Add("May", 7, 55, 45, 80, 35);
            dt.Rows.Add("Jun", 85, 45, 40, 75, 30);



            series1 = new NumericSeries();
            series1.DataBind(dt, "2007", "Month");
            series1.PEs.Add(new PaintElement(Color.Red));
            series1.Label = "Year 2007";
            myColumnLayer.Series.Add(series1);
            ultraChart1.CompositeChart.Series.Add(series1);


            LineAppearance la = new LineAppearance(ultraChart1);
            la.IconAppearance.Icon = SymbolIcon.Circle;
            la.IconAppearance.IconSize = SymbolIconSize.Medium;// Large;
            la.LineStyle.EndStyle = LineCapStyle.DiamondAnchor;
            la.LineStyle.DrawStyle = LineDrawStyle.Dot;
            la.Thickness = 4;
            LineChartAppearance lca = new LineChartAppearance();
            lca.LineAppearances.Add(la);
            myColumnLayer.ChartTypeAppearance = lca;


            ChartTextAppearance cta = new ChartTextAppearance();
            cta.Row = -2;
            cta.Column = -2;
            cta.ItemFormatString = axis1.Labels.ItemFormatString;
            cta.ClipText = true;
            cta.VerticalAlign = StringAlignment.Far;
            cta.ChartTextFont = new Font("Ariel", 18.2F, GraphicsUnit.Pixel);
            cta.ClipText = false;
            cta.Visible = true;
            lca.ChartText.Add(cta);




            series2 = new NumericSeries();
            series2.DataBind(dt, "2008", "Month");
            series2.Label = "Year 2008";
            series2.PEs.Add(new PaintElement(Color.Blue));
            myColumnLayer.Series.Add(series2);
            ultraChart1.CompositeChart.Series.Add(series2);

            series3 = new NumericSeries();
            series3.Data.DataSource = dt;
            series3.Data.ValueColumn = "2009";
            series3.Data.LabelColumn = "Month";
            series3.Label = "Year 2009";
            series3.PEs.Add(new PaintElement(Color.Yellow));
            myColumnLayer.Series.Add(series3);
            ultraChart1.CompositeChart.Series.Add(series3);

            series4 = new NumericSeries();
            series4.DataBind(dt, "2010", "Month");
            series4.Label = "Year 2010";
            series4.PEs.Add(new PaintElement(Color.Green));
            myColumnLayer.Series.Add(series4);
            ultraChart1.CompositeChart.Series.Add(series4);

            series5 = new NumericSeries();
            series5.DataBind(dt, "2011", "Month");
            series5.Label = "Year 2011";
            series5.PEs.Add(new PaintElement(Color.Pink));
            myColumnLayer.Series.Add(series5);
            ultraChart1.CompositeChart.Series.Add(series5);

            myColumnLayer.AxisX = axisX;
            myColumnLayer.AxisY = axis1;
            this.ultraChart1.CompositeChart.ChartLayers.Add(myColumnLayer);

            // Static annotation
            BoxAnnotation ba = new BoxAnnotation();
            ba.Text = "Test 1";
            ba.Location.Type = LocationType.Pixels;
            ba.FillColor = Color.Yellow;
            ba.Visible = true;
            ba.Border.CornerRadius = 10;
            ba.Width = 50;
            ba.Location.LocationX = ultraChart1.Width - 50;
            ba.Location.LocationY = 10;
            ultraChart1.Annotations.Annotations.Add(ba);


            //CompositeLegend myLegend = new CompositeLegend();
            //myLegend.ChartLayers.Add(myColumnLayer);
            //myLegend.Bounds = new Rectangle(5, 85, 80, 12);
            //myLegend.BoundsMeasureType = MeasureType.Percentage;
            //myLegend.PE.ElementType = PaintElementType.Gradient;
            //myLegend.PE.FillGradientStyle = GradientStyle.ForwardDiagonal;
            //myLegend.PE.Fill = Color.CornflowerBlue;
            //myLegend.PE.FillStopColor = Color.Transparent;
            //myLegend.Border.CornerRadius = 10;
            //myLegend.Border.Thickness = 1;
            //this.ultraChart1.CompositeChart.Legends.Add(myLegend);

        }

        private void ultraChart1_FillSceneGraph(object sender, Infragistics.UltraChart.Shared.Events.FillSceneGraphEventArgs e)
        {
            IsValid = true;
            if (ultraChart1.CompositeChart.ChartLayers.Count == 0) return;

            IAdvanceAxis xAxis = (IAdvanceAxis)ultraChart1.CompositeChart.ChartLayers[0].ChartLayer.Grid["X"]; 
            IAdvanceAxis yAxis = (IAdvanceAxis)ultraChart1.CompositeChart.ChartLayers[0].ChartLayer.Grid["Y"]; 
            int width = Math.Abs(endPoint.X - startPoint.X);
            int height = Math.Abs(endPoint.Y - startPoint.Y);
            Box box = new Box(startPoint, width, height);

            if (box.rect.Left < xAxis.MapMinimum || box.rect.Top < yAxis.MapMaximum || box.rect.Right > xAxis.MapMaximum || box.rect.Bottom > yAxis.MapMinimum)
            {
                IsValid = false;
                return;
            }

            if (IsValid)
            {
                if (IsMouseDown)
                {
                    e.SceneGraph.Add(box);
                }

                else if (IsUpdateRequired)
                {
                    IsUpdateRequired = false;
                    double offsetX = (e.ChartCore.GridLayerBounds.Width / xAxis.Scale - e.ChartCore.GridLayerBounds.Width) * xAxis.Scroll;
                    double offsetY = (e.ChartCore.GridLayerBounds.Height / yAxis.Scale - e.ChartCore.GridLayerBounds.Height) * yAxis.Scroll;

                    scaleX = xAxis.Scale * box.rect.Width / ((Infragistics.UltraChart.Core.Layers.Layer)(e.ChartCore.GetChartLayer())).OuterBound.Width;
                    scaleY = yAxis.Scale * box.rect.Height / ((Infragistics.UltraChart.Core.Layers.Layer)(e.ChartCore.GetChartLayer())).OuterBound.Height;
                    scrollX = (box.rect.X - xAxis.MapMinimum + offsetX) / (((Infragistics.UltraChart.Core.Layers.Layer)(e.ChartCore.GetChartLayer())).OuterBound.Width / xAxis.Scale - box.rect.Width);
                    scrollY = (yAxis.MapMinimum - box.rect.Bottom + offsetY) / (((Infragistics.UltraChart.Core.Layers.Layer)(e.ChartCore.GetChartLayer())).OuterBound.Height / yAxis.Scale - box.rect.Height);
                    BeginInvoke(new MethodInvoker(SetChartAxes));
                }
            }
        }

        private void ultraChart1_MouseDown(object sender, MouseEventArgs e)
        {
            startPoint = e.Location;
            IsMouseDown = true;
        }

        private void ultraChart1_MouseUp(object sender, MouseEventArgs e)
        {
            IsMouseDown = false;
            IsUpdateRequired = true;
            ultraChart1.InvalidateLayers();
        }

        private void ultraChart1_MouseMove(object sender, MouseEventArgs e)
        {
            if (IsMouseDown)
            {
                endPoint = e.Location;
                ultraChart1.InvalidateLayers();
            }
        }

        private void SetChartAxes()
        {
            axisX.ScrollScale.Scale = scaleX;
            axis1.ScrollScale.Scale = scaleY;
            axisX.ScrollScale.Scroll = scrollX;
            axis1.ScrollScale.Scroll = scrollY;
        }
    }
}


